Page MenuHomePhabricator

Don't cache resources we can't generate properly
ClosedPublic

Authored by epriestley on Apr 20 2016, 10:25 PM.
Tags
None
Referenced Files
Unknown Object (File)
Sun, Jun 19, 1:40 PM
Unknown Object (File)
Tue, Jun 14, 2:45 AM
Unknown Object (File)
Sun, Jun 12, 10:22 PM
Unknown Object (File)
Mon, Jun 6, 6:23 PM
Unknown Object (File)
May 31 2022, 10:27 PM
Unknown Object (File)
May 29 2022, 4:40 PM
Unknown Object (File)
May 26 2022, 4:50 PM
Unknown Object (File)
May 26 2022, 12:16 PM
Subscribers
None

Details

Summary

Fixes T10843. In a multi-server setup, we can do this:

  • Two servers, A and B.
  • You push an update.
  • A gets pushed first.
  • After A has been pushed, but before B has been pushed, a user loads a page from A.
  • It generates resource URIs like /stuff/new/package.css.
  • Those requests hit B.
  • B doesn't have the new resources yet.
  • It responds with old resources.
  • Your CDN caches things. You now have a poisoned CDN: old data is saved in a new URL.

To try to avoid this with as little work as possible and generally make it hard to get wrong, check the URL hash against the hash we would generate.

If they don't match, serve our best guess at the resource, but don't cache it. This should make things mostly keep working during the push, but prevent caches from becoming poisoned, and everyone should get a working version of everything after the push finishes.

Test Plan
  • curl'd a resource, got a cacheable one.
  • Changed the hash a little, curl'd again. This time: valid resource, but not cacheable.

Diff Detail

Repository
rP Phabricator
Lint
Lint Not Applicable
Unit
Tests Not Applicable

Event Timeline

epriestley retitled this revision from to Don't cache resources we can't generate properly.
epriestley updated this object.
epriestley edited the test plan for this revision. (Show Details)
epriestley added a reviewer: chad.
chad edited edge metadata.
This revision is now accepted and ready to land.Apr 21 2016, 5:30 PM
This revision was automatically updated to reflect the committed changes.